#include "DxLib.h"

#define PLAYER_SIZE				200.0f			// vC[̋̔a
#define PLAYER_SPEED			30.0f			// vC[̑x
#define SHADOW_SETUP_SIZE		900.0f			// ȅ`͈
#define SHADOW_CAPSULE_WIDTH	500.0f			// e̕`悷ۂ̃|SoɎgpJvZ̔a
#define SHADOW_CAPSULE_LENGTH	2000.0f			// e`悷ۂ̃|SoɎgpJvZ̒

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	int SceneModel, ShadowRenderTexture, i, CharaModelHandle ;
	VECTOR Position, MoveVec, MovePos ;
	MV1_COLL_RESULT_POLY_DIM HitResDim ;
	MV1_COLL_RESULT_POLY *HitRes, LineHitRes ;
	VERTEX3D Vertex[ 3 ] ;
	VECTOR CapsuleStart, CapsuleEnd ;
	int AttachAnimIndex ;
	float AnimCounter ;

	ChangeWindowMode( TRUE ) ;

	// cwCȕ
	if( DxLib_Init() < 0 )
		return -1 ;

	// nʂ̃fǂݍ
	SceneModel = MV1LoadModel( "Jimen.mqo" ) ;

	// At@`lt`\eNX`̍쐬
	SetDrawValidGraphCreateFlag( TRUE ) ;
	SetDrawValidAlphaChannelGraphCreateFlag( TRUE ) ;
	ShadowRenderTexture = MakeGraph( 256, 256 ) ;	// TCY 256x256Aʂ傫TCYƍ̂Ƃ됳ɓ삵܂
	SetDrawValidAlphaChannelGraphCreateFlag( FALSE ) ;
	SetDrawValidGraphCreateFlag( FALSE ) ;

	// LN^f̓ǂݍ
	CharaModelHandle = MV1LoadModel( "DxChara.x" ) ;

	// [gt[̂yAj[V̖
	{
		MATRIX LocalMatrix ;

		// [U[s
		MV1ResetFrameUserLocalMatrix( CharaModelHandle, 2 ) ;

		// ݂̃[gt[̍s擾
		LocalMatrix = MV1GetFrameLocalMatrix( CharaModelHandle, 2 ) ;

		// y̕sړ𖳌ɂ
		LocalMatrix.m[ 3 ][ 2 ] = 0.0f ;

		// [U[sƂĕsړ𖳌ɂs[gt[ɃZbg
		MV1SetFrameUserLocalMatrix( CharaModelHandle, 2, LocalMatrix ) ;
	}

	// 郂[VA^b`
	AttachAnimIndex = MV1AttachAnim( CharaModelHandle, 1 ) ;
	AnimCounter = 0.0f ;

	// RW̃ZbgAbv
	MV1SetupCollInfo( SceneModel, -1, 32, 1, 32 ) ;

	// `𗠉ʂɂ
	SetDrawScreen( DX_SCREEN_BACK ) ;

	// vC[̈ʒu
	LineHitRes = MV1CollCheck_Line( SceneModel, -1, VGet( 0.0f, 2000.0f, 0.0f ), VGet( 0.0f, -2000.0f, 0.0f ) ) ;
	Position = LineHitRes.HitPosition ;
	Position.y += PLAYER_SIZE ;

	// J̈ʒu
	SetCameraNearFar( 100.0f, 8000.0f ) ;
	SetCameraPositionAndTarget_UpVecY( VGet( 0.0f, 1500.0f, -4000.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;

	// yobt@gp
	SetUseZBuffer3D( TRUE ) ;
	SetWriteZBuffer3D( TRUE ) ;

	// C[v
	// GXP[vL[ꂽI
	while( ProcessMessage() == 0 && CheckHitKey( KEY_INPUT_ESCAPE ) == 0 )
	{
		MATRIX LightMatrix ;
		VECTOR LightDir, LightPos, LightTargetPos ;

		// vC[㉺Eňړ
		MoveVec = VGet( 0.0f, 0.0f, 0.0f ) ;
		if( CheckHitKey( KEY_INPUT_LEFT  ) == 1 ) MoveVec.x = -PLAYER_SPEED ;
		if( CheckHitKey( KEY_INPUT_RIGHT ) == 1 ) MoveVec.x =  PLAYER_SPEED ;
		if( CheckHitKey( KEY_INPUT_UP    ) == 1 ) MoveVec.z =  PLAYER_SPEED ;
		if( CheckHitKey( KEY_INPUT_DOWN  ) == 1 ) MoveVec.z = -PLAYER_SPEED ;

		// ړɒnʂꍇ݈̂ړ
		MovePos = VAdd( Position, MoveVec ) ;
		LineHitRes = MV1CollCheck_Line( SceneModel, -1, VAdd( MovePos, VGet( 0.0f, 2000.0f, 0.0f ) ), VAdd( MovePos, VGet( 0.0f, -2000.0f, 0.0f ) ) ) ;
		if( LineHitRes.HitFlag )
		{
			Position = MovePos ;
			Position.y = LineHitRes.HitPosition.y + 100.0f ;
		}

		// Aj[V
		AnimCounter += 100.0f ;
		if( AnimCounter > MV1GetAttachAnimTotalTime( CharaModelHandle, AttachAnimIndex ) )
		{
			AnimCounter -= MV1GetAttachAnimTotalTime( CharaModelHandle, AttachAnimIndex ) ;
		}
		MV1SetAttachAnimTime( CharaModelHandle, AttachAnimIndex, AnimCounter ) ;

		// vC[̉epeNX`̏
		{
			// }eA̐ݒ𔽉f邽߂ɃCeBOLɂ
			// ( 2012/4/8 ύX )
			SetUseLighting( TRUE ) ;

			// ``\At@`lt摜ɂ
			SetDrawScreen( ShadowRenderTexture ) ;

			// eNX`̓eNA
			ClearDrawScreen() ;

			// J̎ˉe[h𐳎ˉeɂ
			SetupCamera_Ortho( SHADOW_SETUP_SIZE ) ;

			// Cǧ擾
			LightDir = GetLightDirection() ;

			// Cg𓖂ĂΏۂ̍WZo( LN^f̒Sӂ )
			LightTargetPos = VAdd( Position, VGet( 0.0f, 300.0f, 0.0f ) ) ;

			// Cg̈ʒu( Cg𓖂ĂΏۂ烉Cg̕ 1500.0f ꂽʒuA
			// Cg𓖂ĂΏۂɂ߂荞ލWłȂ Far NbvȂlȂ牽łnj )
			LightPos = VSub( LightTargetPos, VScale( LightDir, 1500.0f ) ) ;

			// Cg̈ʒu烉Cg𓖂ĂΏۂĂJݒ
			SetCameraPositionAndTarget_UpVecY( LightPos, LightTargetPos ) ;

			// L֐Őݒ肳ꂽr[sƎˉes|킹̂
			// ( e`掞̂tuWZoɎgp )
			LightMatrix = MMult( GetCameraViewMatrix(), GetCameraProjectionMatrix() ) ;

			// vC[̈ʒuZbg
			MV1SetPosition( CharaModelHandle, Position ) ;

			// vC[^ɕ`悳悤ɐFp[^Zbg
			MV1SetDifColorScale( CharaModelHandle, GetColorF( 0.0f, 0.0f, 0.0f, 1.0f ) ) ;
			MV1SetSpcColorScale( CharaModelHandle, GetColorF( 0.0f, 0.0f, 0.0f, 1.0f ) ) ;
			MV1SetEmiColorScale( CharaModelHandle, GetColorF( 0.0f, 0.0f, 0.0f, 1.0f ) ) ;
			MV1SetAmbColorScale( CharaModelHandle, GetColorF( 0.0f, 0.0f, 0.0f, 1.0f ) ) ;

			// vC[epeNX`ɕ`
			MV1DrawModel( CharaModelHandle ) ;

			// vC[^ɕ`悳悤ɐݒ肵Fp[^ɖ߂
			MV1SetDifColorScale( CharaModelHandle, GetColorF( 1.0f, 1.0f, 1.0f, 1.0f ) ) ;
			MV1SetSpcColorScale( CharaModelHandle, GetColorF( 1.0f, 1.0f, 1.0f, 1.0f ) ) ;
			MV1SetEmiColorScale( CharaModelHandle, GetColorF( 1.0f, 1.0f, 1.0f, 1.0f ) ) ;
			MV1SetAmbColorScale( CharaModelHandle, GetColorF( 1.0f, 1.0f, 1.0f, 1.0f ) ) ;
		}

		// `𗠉ʂɂ
		SetDrawScreen( DX_SCREEN_BACK ) ;

		// ʂ̃NA
		ClearDrawScreen() ;
		DrawBox( 0, 0, 1000, 1000, GetColor( 255,0,0 ), TRUE ) ;

		// J̐ݒȂ
		SetCameraNearFar( 100.0f, 8000.0f ) ;
		SetCameraPositionAndTarget_UpVecY( VGet( 0.0f, 1500.0f, -4000.0f ), VGet( 0.0f, 0.0f, 0.0f ) ) ;

		// vC[̕`
		{
			// CeBOLɂ
			SetUseLighting( TRUE ) ;

			// ʒu͉e̕`掞ɐݒ肵Ă̂ł`悷邾
			MV1DrawModel( CharaModelHandle ) ;
		}

		// nʂ̕`
		MV1DrawModel( SceneModel ) ;

		// e̕`
		{
			// CeBO𖳌ɂ
			SetUseLighting( FALSE ) ;

			// eNX`AhX[h CLAMP ɂ( eNX`̒[͒[̃hbgX )
			SetTextureAddressMode( DX_TEXADDRESS_CLAMP ) ;

			// ̒ɑ݂nʂ̃|S擾
			CapsuleStart = LightTargetPos ;
			CapsuleEnd = VAdd( CapsuleStart, VScale( LightDir, SHADOW_CAPSULE_LENGTH ) ) ;
			HitResDim = MV1CollCheck_Capsule( SceneModel, -1, CapsuleStart, CapsuleEnd, SHADOW_CAPSULE_WIDTH ) ;

			// _f[^ŕωZbg
			Vertex[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
			Vertex[ 0 ].spc = GetColorU8( 0,0,0,0 ) ;
			Vertex[ 0 ].su = 0.0f ;
			Vertex[ 0 ].sv = 0.0f ;
			Vertex[ 1 ] = Vertex[ 0 ] ;
			Vertex[ 2 ] = Vertex[ 0 ] ;

			// ̒ɑ݂|S̐JԂ
			HitRes = HitResDim.Dim ;
			for( i = 0 ; i < HitResDim.HitNum ; i ++, HitRes ++ )
			{
				// |S̍W͒nʃ|S̍W
				Vertex[ 0 ].pos = HitRes->Position[ 0 ] ;
				Vertex[ 1 ].pos = HitRes->Position[ 1 ] ;
				Vertex[ 2 ].pos = HitRes->Position[ 2 ] ;

				// ƎグďdȂȂ悤ɂ
				Vertex[ 0 ].pos.y += 5.0f ;
				Vertex[ 1 ].pos.y += 5.0f ;
				Vertex[ 2 ].pos.y += 5.0f ;

				// tulZo
				// |S̍WƉeeNX`̏Ɏgps|킹 -1.0f`1.0f ̒l̂ŁA
				//  0.0f`1.0f ͈̔͂ɂ邽߂ + 1.0f  * 0.5f Ă܂Av ͏㉺΂̒lɂȂ̂ŁA( 1.0f - Zol ) Ă܂
				Vertex[ 0 ].u =        ( LightMatrix.m[ 0 ][ 0 ] * HitRes->Position[ 0 ].x + LightMatrix.m[ 1 ][ 0 ] * HitRes->Position[ 0 ].y + LightMatrix.m[ 2 ][ 0 ] * HitRes->Position[ 0 ].z + LightMatrix.m[ 3 ][ 0 ] + 1.0f ) * 0.5f ;
				Vertex[ 0 ].v = 1.0f - ( LightMatrix.m[ 0 ][ 1 ] * HitRes->Position[ 0 ].x + LightMatrix.m[ 1 ][ 1 ] * HitRes->Position[ 0 ].y + LightMatrix.m[ 2 ][ 1 ] * HitRes->Position[ 0 ].z + LightMatrix.m[ 3 ][ 1 ] + 1.0f ) * 0.5f ;
				Vertex[ 1 ].u =        ( LightMatrix.m[ 0 ][ 0 ] * HitRes->Position[ 1 ].x + LightMatrix.m[ 1 ][ 0 ] * HitRes->Position[ 1 ].y + LightMatrix.m[ 2 ][ 0 ] * HitRes->Position[ 1 ].z + LightMatrix.m[ 3 ][ 0 ] + 1.0f ) * 0.5f ;
				Vertex[ 1 ].v = 1.0f - ( LightMatrix.m[ 0 ][ 1 ] * HitRes->Position[ 1 ].x + LightMatrix.m[ 1 ][ 1 ] * HitRes->Position[ 1 ].y + LightMatrix.m[ 2 ][ 1 ] * HitRes->Position[ 1 ].z + LightMatrix.m[ 3 ][ 1 ] + 1.0f ) * 0.5f ;
				Vertex[ 2 ].u =        ( LightMatrix.m[ 0 ][ 0 ] * HitRes->Position[ 2 ].x + LightMatrix.m[ 1 ][ 0 ] * HitRes->Position[ 2 ].y + LightMatrix.m[ 2 ][ 0 ] * HitRes->Position[ 2 ].z + LightMatrix.m[ 3 ][ 0 ] + 1.0f ) * 0.5f ;
				Vertex[ 2 ].v = 1.0f - ( LightMatrix.m[ 0 ][ 1 ] * HitRes->Position[ 2 ].x + LightMatrix.m[ 1 ][ 1 ] * HitRes->Position[ 2 ].y + LightMatrix.m[ 2 ][ 1 ] * HitRes->Position[ 2 ].z + LightMatrix.m[ 3 ][ 1 ] + 1.0f ) * 0.5f ;

				// e|S`
				DrawPolygon3D( Vertex, 1, ShadowRenderTexture, TRUE ) ;
			}

			// e`悷ۂɗ񋓂|Šo͈͂킩悤ɂ邽߂̃JvZ`
			// RgAEgĂɎx͂܂
			DrawCapsule3D( CapsuleStart, CapsuleEnd, SHADOW_CAPSULE_WIDTH, 16, GetColor( 255,255,0 ), 0, FALSE ) ;

			// onʃ|Šn
			MV1CollResultPolyDimTerminate( HitResDim ) ;
		}

		// eeNX`ǂȂĂ邩𕪂悤ɂ邽߂̕`
		// RgAEgĂɎx͂܂
		DrawGraph( 0, 0, ShadowRenderTexture, TRUE ) ;

		// ʂ̓e\ʂɔf
		ScreenFlip() ;
	}

	// cwCǔn
	DxLib_End() ;

	// \tg̏I
	return 0 ;
}
